% enable with PCA
%compute the dictionary of center view
fprintf('compute dictionary ...\n');
params.PaSR.SR_factor = lev_f^(lev_num-1);

if p2sr_iter == 1 % compute the center view
    if params.PaSR.UsingPCA
        dict_path = sprintf('%s/PaSR_dict_t%02d_s%02d_lp%d_SR_%d_PCA.mat',out_path,0,0,params.PaSR.lpatch_size,params.PaSR.SR_factor);
    else
        dict_path = sprintf('%s/PaSR_dict_t%02d_s%02d_lp%d_SR_%d.mat',out_path,0,0,params.PaSR.lpatch_size,params.PaSR.SR_factor);
    end
    fprintf('computing %s ... \n',dict_path);
    if ~params.PaSR_dict_done(p2sr_iter)
        im_h_refs = {};
        im_h_refs{1} = pyr{t_c,s_c,lev_num};
        
        [lf_feats,lf_inds] = GetLFeat2(im_h_refs,params.PaSR);
        if params.PaSR.UsingPCA
            CmpPCADict;
            lf_feats = pca_base*lf_feats;
            save(dict_path,'-v7.3','pca_base','pca_mean','pca_std','lf_feats','lf_inds');
        else
            save(dict_path,'-v7.3','lf_feats','lf_inds');
        end
        
        clear lf_feats lf_inds;
       
    else
        if ~exist(dict_path,'file')
            error(sprintf('%s not exist!',dict_path));
        end
    end
    
    
    fprintf('done\n');
    
else
    lev = lev_num;
    params.PASR.SR_factor = lev_f^(lev_num - 1);
    for t = t_begin:t_end
        for s = s_begin:s_end
            
            % jump the computation for center view
            if s == 0 && t ==0
                continue;
            end
            
            im_ref_cur{1} = pyr_P2SR_syn{p2sr_iter-1}{t+t_c,s+s_c,lev};
            
            if params.PaSR.UsingPCA
                dict_path = sprintf('%s/PaSR_dict_t%02d_s%02d_lp%d_SR_%d_iter%d_PCA.mat',out_path,t,s,params.PaSR.lpatch_size,params.PaSR.SR_factor,p2sr_iter);
            else
                dict_path = sprintf('%s/PaSR_dict_t%02d_s%02d_lp%d_SR_%d_iter%d.mat',out_path,t,s,params.PaSR.lpatch_size,params.PaSR.SR_factor,p2sr_iter);
            end
            if params.PaSR_dict_done(p2sr_iter) && exist(dict_path,'file')
                fprintf('exist %s\n',dict_path);
            else
                
                [lf_feats,lf_inds] = GetLFeat2(im_ref_cur,params.PaSR);
                if params.PaSR.UsingPCA
                    CmpPCADict;
                    lf_feats = pca_base*lf_feats;
                    save(dict_path,'-v7.3','pca_base','pca_mean','pca_std','lf_feats','lf_inds');
                else
                    save(dict_path,'-v7.3','lf_feats','lf_inds');
                end
                clear lf_feats lf_inds;
                
              
            end
        end
    end
end

