% build one dict for all the images inside im_h_ref,which is a cell
function [lfeat,lfeat_inds] = GetLFeat2(im_h_refs,params)

p_size = params.lpatch_size * params.SR_factor;
h_n = length(im_h_refs);
for k = 1:h_n
    im_h_refs{k} = double(rgb2gray(im_h_refs{k}));
    im_h_refs{k} = im_h_refs{k}/255; % map to [0,1]
end
[h,w] = size(im_h_refs{1});

fg1 = [-1,0,1];
fg2 = fg1';
fg3 = [1,0,-2,0,1];
fg4 = fg3';

feat_dims = 4*params.lpatch_size^2;
feat_num = length(1:w - p_size +1)*length(1:h - p_size +1)*h_n;

lfeat = zeros(feat_dims,feat_num);
lfeat_inds = zeros(feat_num,3); % im_id, y,x

ind_count = 0;
t = tic;


% get resize T matrix
sp_size = params.lpatch_size;
lp_size = params.lpatch_size*params.SR_factor;
T = zeros(sp_size*sp_size,lp_size*lp_size);
k = 0;
for x = 1:lp_size
    for y = 1:lp_size
        k = k+1;
        M = zeros(lp_size,lp_size);
        M(y,x) = 1;
        M = imresize(M,sp_size/lp_size,'bilinear');
        T(:,k) = M(:);
    end
end

% fprintf('extract feature dict: ');
for k = 1:h_n
    fprintf('get dict %d ',k);
    for x = 1:w - p_size +1
        if ~mod(x,10)
            fprintf('.');
        end
        cur_x_ind = x:x + p_size -1;
        for y = 1:h - p_size +1
            
            cur_y_ind = y:y+p_size -1;
            cur_patch = im_h_refs{k}(cur_y_ind,cur_x_ind);
            
            %             cur_patch = imresize(cur_patch,1/params.SR_factor,'bilinear');
            cur_patch = reshape(T*cur_patch(:),sp_size,sp_size);
            
            %
            
            % extract feature
            patch_feat_1 = filter2(fg1,cur_patch);
            patch_feat_2 = filter2(fg2,cur_patch);
            patch_feat_3 = filter2(fg3,cur_patch);
            patch_feat_4 = filter2(fg4,cur_patch);
            
            ind_count = ind_count +1;
            lfeat_inds(ind_count,:) = [k,y,x];
            lfeat(:,ind_count) = [patch_feat_1(:);patch_feat_2(:);patch_feat_3(:);patch_feat_4(:)];
            
        end
    end
    fprintf('\n');
end

toc(t);