function [im_sr_lr, im_sr]= InferSR3(lf_feats,lf_inds,im_h_refs,im_l,params)

h_n = length(im_h_refs);

cur_beta = params.beta;

for k = 1:h_n
    im_h_refs{k} = double(im_h_refs{k})/255;
end

im_l_c = double(im_l);
im_l_c = im_l_c/255;
im_l_g = double(rgb2gray(im_l));
im_l_g = im_l_g/255;
[h,w] = size(im_l_g);

hpatch_size = params.SR_factor*params.lpatch_size;
w_count = zeros(h*params.SR_factor,w*params.SR_factor);
im_sr = zeros(h*params.SR_factor,w*params.SR_factor,3);
im_sr_lr = im_sr;

fg1 = [-1,0,1];
fg2 = fg1';
fg3 = [1,0,-2,0,1];
fg4 = fg3';

feat_num = size(lf_feats,2);
lf_feats = single(lf_feats);

% G_lf_inds = gpuArray(lf_inds(:,2:3));
% G_ones = gpuArray(ones(feat_num,1));
gpu = gpuDevice();
G1 = gpuArray(lf_inds(:,2));
G2 = gpuArray(lf_inds(:,3));


tic;
for x = 1:w-params.lpatch_size +1
    fprintf('.');
    cur_x_ind = x:x+params.lpatch_size-1;
    for y = 1:h-params.lpatch_size +1
        
        

        sr_p_x = (x-1)*params.SR_factor +1;
        sr_p_y = (y-1)*params.SR_factor +1;
        
        cur_y_ind = y:y+params.lpatch_size-1;
        
        cur_patch = im_l_g(cur_y_ind,cur_x_ind);
        cur_patch_rgb = im_l_c(cur_y_ind,cur_x_ind,:);
        patch_feat_1 = filter2(fg1,cur_patch);
        patch_feat_2 = filter2(fg2,cur_patch);
        patch_feat_3 = filter2(fg3,cur_patch);
        patch_feat_4 = filter2(fg4,cur_patch);

        cur_feat = [patch_feat_1(:);patch_feat_2(:);patch_feat_3(:);patch_feat_4(:)];
        %         G_cur_feat = gpuArray(cur_feat);
        cur_feat = single(cur_feat);

        %select calidate patch with in possible area
        % save('speed_up_sr','lf_inds','feat_num','sr_p_y','sr_p_x');
        
        %         pos_dis = max(abs(ones(feat_num,1)*[sr_p_y,sr_p_x] - lf_inds(:,2:3)),[],2);
        %        sel_ind = find(pos_dis < params.search_range);
        
        p1 = G1 - gpuArray(sr_p_y);
        p2 = G2 - gpuArray(sr_p_x);
        
        
        p1 = abs(p1);
        p2 = abs(p2);
        
        G3 = gpuArray( params.search_range);
        
        s1 =  (p1 < G3).*(p2 < G3);
        
        
        sel_ind = find(s1);
        
        
        cur_lf_feats = lf_feats(:,sel_ind);
        cur_lf_inds = lf_inds(sel_ind,:);
        cur_feat_num = length(sel_ind);

        dis = sum((cur_feat*ones(1,cur_feat_num) - cur_lf_feats).^2);

        %         dis = sum((G_cur_feat*G_ones - G_lf_feats).^2);
        

        min_dis = zeros(1,params.nn);
        min_ind = zeros(1,params.nn);
        for k = 1:params.nn
            [cur_val,cur_ind] = min(dis);
            min_dis(k) = cur_val;
            min_ind(k) = cur_ind;
            dis(cur_ind) = 1e+15;
        end
        
        %         [min_dis,min_ind] = sort(dis);
        %         tic;
        %         flann_params.algorithm = 'kdtree';
        %         flann_params.trees = 64;
        %         flann_params.checks = 64;
        %         % perform the nearest-neighbor search
        %         [result, dists] = flann_search(lf_feats,cur_feat,5,flann_params)
        %         toc;
        p_weight = exp(cur_beta* min_dis);
        
        beta_decay = 0.5;
        while max(p_weight) < 1e-10
            p_weight = exp(beta_decay*cur_beta* min_dis);
            beta_decay = beta_decay*0.5;
        end
        
        p_weight = p_weight/sum(p_weight);
        
        sr_patch = zeros(hpatch_size,hpatch_size,3);
        for k = 1:params.nn
            cur_im_ind = cur_lf_inds(min_ind(k),1);
            cur_im_y = cur_lf_inds(min_ind(k),2);
            cur_im_x = cur_lf_inds(min_ind(k),3);
            sr_patch = sr_patch + p_weight(k)*im_h_refs{cur_im_ind}(cur_im_y:cur_im_y+hpatch_size-1,cur_im_x:cur_im_x+hpatch_size-1,:);
        end
        % replace low frequency

        
        im_sr(sr_p_y:sr_p_y+hpatch_size-1,sr_p_x:sr_p_x+hpatch_size-1,:) = im_sr(sr_p_y:sr_p_y+hpatch_size-1,sr_p_x:sr_p_x+hpatch_size-1,:)+ sr_patch;
        
        sr_patch_h = sr_patch - imresize(imresize(sr_patch,1/params.SR_factor,'bilinear'),params.SR_factor,'bilinear');
        sr_patch = sr_patch_h + imresize(cur_patch_rgb,params.SR_factor,'bilinear');
        
        im_sr_lr(sr_p_y:sr_p_y+hpatch_size-1,sr_p_x:sr_p_x+hpatch_size-1,:) = im_sr_lr(sr_p_y:sr_p_y+hpatch_size-1,sr_p_x:sr_p_x+hpatch_size-1,:)+ sr_patch;
        
        w_count(sr_p_y:sr_p_y+hpatch_size-1,sr_p_x:sr_p_x+hpatch_size-1) = w_count(sr_p_y:sr_p_y+hpatch_size-1,sr_p_x:sr_p_x+hpatch_size-1) +1;

    end
end

w_count(w_count==0) = 1;

im_sr(:,:,1) = im_sr(:,:,1)./w_count;
im_sr(:,:,2) = im_sr(:,:,2)./w_count;
im_sr(:,:,3) = im_sr(:,:,3)./w_count;
im_sr = uint8(im_sr*255);

im_sr_lr(:,:,1) = im_sr_lr(:,:,1)./w_count;
im_sr_lr(:,:,2) = im_sr_lr(:,:,2)./w_count;
im_sr_lr(:,:,3) = im_sr_lr(:,:,3)./w_count;
im_sr_lr = uint8(im_sr_lr*255);

wait(gpu);
reset(gpu);
toc;
end

