%t
clear;
close all;

addpath (genpath('./matlabPyrTools-1.3/'));
addpath (genpath('./Stereo Matching/'));
addpath (genpath('./optical_flow/'));

dataset_name = 'scene_300';

im_path = ['./data_1/',dataset_name];
disp_path = [im_path,'/disp_gt'];

out_path = ['./res/',dataset_name];
out_path_disp = ['./res/',dataset_name,'/disp'];

if ~exist(out_path,'dir')
    mkdir(out_path);
end
if ~exist(out_path_disp,'dir')
    mkdir(out_path_disp);
end

% set params
params.PaSR_dict_done = [ 0 0 0 0 0 0 0 0 0 0 0 0 0 ];
params.PaSR_done = [0 0 0 0 0 0 0 0 0 0 0 0 ]; % label if the PaSR is done for iter
% params.WaSR_done = [0 0 0 0 0 0 0 0 0 0 0 0 0];
params.PhSR_disp_init_done = [0 0 0 0];
params.PhSR_done = [0 0 0 0];
params.P2SR_syn_done = [0 0 0 0];
    
params.PaSR_lr = 1;

params.p2sr_factor = 8;

% Params
params.UseParallelToolbox = false;
params.ParallelWorkers = 8;

% for CmpDisp %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
params.PhSR.UseParallelToolbox = params.UseParallelToolbox;
% params.PhSR.filter_kernel_for_levels = [15,21,31,51]; % for different lev
% params.PhSR.disp_range_for_levels = [7,13,25,51]; %[-range/2-1,range/2]

params.PhSR.filter_kernel_for_levels = [15,21,31,25]; % for different lev
params.PhSR.disp_range_for_levels = [7,13,25,21]; %[-range/2-1,range/2]
params.PhSR.filter_kernel_small = 11;
params.PhSR.disp_range_small = 15;
params.PhSR.downSampling = 1/2;

params.PhSR.filter_kernel_selfrefine= 91;
params.PhSR.disp_range_self_refine = 15;

params.PhSR.eps = 0.0001;
params.PhSR.thresColor = 2/255;
params.PhSR.thresGrad = 1/255;
params.PhSR.gamma = 0.11;
params.PhSR.threshBorder = 3/255;
params.PhSR.gamma_c = 0.1;
params.PhSR.gamma_d = 9;
params.PhSR.r_median = 50;
params.PhSR.maskSize = [3 3];
params.PhSR.maskSigma = 0.00001;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% for syn synthesis image %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

params.PhSR.lev_num = 1;
params.PhSR.ori_num = 4;
params.PhSR.refine_dis = 1;
params.PhSR.iter_refine = 2;
params.PhSR.disp_path = out_path_disp;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% for SR %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
params.PaSR.UsingPCA = 1;
params.PaSR.lpatch_size = 8;
params.PaSR.nn = 9;
params.PaSR.search_range_for_levels = [11,17,23,21]; %  [-range,range ]
params.PaSR.beta = - 0.0125;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if (params.UseParallelToolbox)
    isOpen = matlabpool('size') > 0;
    if (isOpen)
        matlabpool close force local
    end
    matlabpool(params.ParallelWorkers)
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
t_begin = -1;
t_end = 1;
s_begin = -1;
s_end = 1;


%
lev_f = 2;
lev_num = 4;

% im_hr_h = 1728;
% im_hr_w = 2848;
% im_lr_h = 216;
% im_lr_w = 356;

%scene 04
im_hr_h = 768;
im_hr_w = 768;
im_lr_h = im_hr_h/8;
im_lr_w = im_hr_w/8;

% im_hr_h = 1728/4;
% im_hr_w = 2848/4;
% 
% im_lr_h = 216/4;
% im_lr_w = 356/4;

% im_hr_h = 240;
% im_hr_w = 400;
% im_lr_h = 30;
% im_lr_w = 50;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
BuildPyrGT; % ground truth with the center view and othe views
BuildPyr; % only the center view and low resolution view

pyr_PaSR = {};
pyr_PaSR_lr = {};

pyr_PhSR = {};

pyr_P2SR_syn = {};

psnr_PaSR = {};
psnr_PhSR = {};


for p2sr_iter = 1:4
    CmpSRDict; % compute PaSR dictionary for center view
    PaSR;
    PhSR;
%     PhSR_WarpInit;
end








