% init
pyr_PaSR{p2sr_iter} = pyr;
pyr_PaSR_lr{p2sr_iter} = pyr;
psnr_PaSR = [];
% compute each view for super resolution by first compute the largest
% resolution image

params.PaSR.SR_factor = lev_f^(lev_num - 1);
params.PaSR.search_range = params.PaSR.search_range_for_levels(lev_num);



for t = t_begin:t_end
    for s = s_begin:s_end
        lev = lev_num;
        fprintf('infer pyr_sr s %d t %d\n',s,t);
        cur_ver = sprintf('PaSR_%d',p2sr_iter);
        if params.PaSR_done(p2sr_iter) && isMyIMExist(out_path,lev,s,t,cur_ver)            
            pyr_PaSR{p2sr_iter}{t+t_c,s+s_c,lev} = MyReadIM(out_path,lev,s,t,cur_ver);
            pyr_PaSR_lr{p2sr_iter}{t+t_c,s+s_c,lev} = MyReadIM(out_path,lev,s,t,[cur_ver,'_lr']);
        else
            if ~params.PaSR.UsingPCA
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                % version 1: only use the center view and the same view PhSR
                % we need to load the dictionary
                % build the current dict
                
                % load the center view dict
                dict_path = sprintf('%s/PaSR_dict_t%02d_s%02d_lp%d_SR_%d.mat',out_path,0,0,params.PaSR.lpatch_size,params.PaSR.SR_factor);
                if ~exist(dict_path,'file')
                    warning('not exist %s\n',dict_path);
                else
                    load(dict_path);
                end
                im_h_refs = {};
                im_h_refs{1} = pyr{t_c,s_c,lev_num};
                
                if p2sr_iter > 1
                    dict_path = sprintf('%s/PaSR_dict_t%02d_s%02d_lp%d_SR_%d_iter%d.mat',out_path,t,s,params.PaSR.lpatch_size,params.PaSR.SR_factor,p2sr_iter);
                    if ~exist(dict_path,'file')
                        warning('not exist %s\n',dict_path);
                    else
                        cur_dict = load(dict_path);
                        lf_feats = [lf_feats,cur_dict.lf_feats];
                        cur_dict.lf_inds(:,1) = cur_dict.lf_inds(:,1)*2;
                        lf_inds = [lf_inds;cur_dict.lf_inds];
                        clear cur_dict;
                        im_h_refs{2} = pyr_P2SR_syn{p2sr_iter-1}{t+t_c,s+s_c,lev_num};
                    end
                end
                
                
                if s == 0 && t==0
                    pyr_PaSR{p2sr_iter}{t+t_c,s+s_c,lev} = pyr{t+t_c,s+s_c,lev};
                    pyr_PaSR_lr{p2sr_iter}{t+t_c,s+s_c,lev} = pyr{t+t_c,s+s_c,lev};
                else
                    [im_PaSR,im_PaSR_lr] = InferSR2(lf_feats,lf_inds,im_h_refs, pyr{t+t_c,s+s_c,1},params.PaSR);
                    clear('lf_feats','lf_inds');

                    pyr_PaSR{p2sr_iter}{t+t_c,s+s_c,lev} = im_PaSR;
                    pyr_PaSR_lr{p2sr_iter}{t+t_c,s+s_c,lev} = im_PaSR_lr;
                    
                end
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            else
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                %using PCA version
                pca_base_all = {};
                pca_mean_all = {};
                pca_std_all = {};
                lf_feats_all = {};
                lf_inds_all = {};
                im_h_refs = {};
                dict_path = sprintf('%s/PaSR_dict_t%02d_s%02d_lp%d_SR_%d_PCA.mat',out_path,0,0,params.PaSR.lpatch_size,params.PaSR.SR_factor);
                if ~exist(dict_path,'file')
                    warning('not exist %s\n',dict_path);
                else
                    load(dict_path);
                    lf_feats_all{1} = lf_feats;
                    lf_inds_all{1} = lf_inds;
                    
                    pca_base_all{1} = pca_base;
                    pca_mean_all{1} = pca_mean;
                    pca_std_all{1} = pca_std;
                    im_h_refs{1} = pyr{t_c,s_c,lev_num};
                    clear lf_feats lf_inds pca_base pca_mean pca_std; 
                end
                
                
                
                if p2sr_iter > 1
                    if t ~=0 || s~=0
                        dict_path = sprintf('%s/PaSR_dict_t%02d_s%02d_lp%d_SR_%d_iter%d_PCA.mat',out_path,t,s,params.PaSR.lpatch_size,params.PaSR.SR_factor,p2sr_iter);
                        if ~exist(dict_path,'file')
                            warning('not exist %s\n',dict_path);
                        else
                            load(dict_path);
                            lf_feats_all{2} = lf_feats;
                            lf_inds(:,1) = 2*lf_inds(:,1);
                            lf_inds_all{2} = lf_inds;
                            
                            pca_base_all{2} = pca_base;
                            pca_mean_all{2} = pca_mean;
                            pca_std_all{2} = pca_std;
                            im_h_refs{2} = pyr_P2SR_syn{p2sr_iter-1}{t+t_c,s+s_c,lev_num};
                            clear lf_feats lf_inds pca_base pca_mean pca_std;
                        end
                    end
                end
                
                
                if s == 0 && t==0
                    pyr_PaSR{p2sr_iter}{t+t_c,s+s_c,lev} = pyr{t+t_c,s+s_c,lev};
                    pyr_PaSR_lr{p2sr_iter}{t+t_c,s+s_c,lev} = pyr{t+t_c,s+s_c,lev};
                else
                    [im_PaSR,im_PaSR_lr] = InferSR2_PCA(lf_feats_all,lf_inds_all,im_h_refs, pyr{t+t_c,s+s_c,1},pca_base_all,pca_mean_all,pca_std_all,params.PaSR);
                    clear lf_feats lf_inds pca_base_all pca_mean_all pca_std_all;
                    
                    pyr_PaSR{p2sr_iter}{t+t_c,s+s_c,lev} = im_PaSR;
                    pyr_PaSR_lr{p2sr_iter}{t+t_c,s+s_c,lev} = im_PaSR_lr;
                end
                
                
            end
%             MySaveIM(im_PaSR_nolr,out_path,lev,s,t,[cur_ver,'_nolr',sprintf('%f',params.PaSR.beta)]);
            MySaveIM( pyr_PaSR{p2sr_iter}{t+t_c,s+s_c,lev},out_path,lev,s,t,cur_ver);
            MySaveIM(pyr_PaSR_lr{p2sr_iter}{t+t_c,s+s_c,lev},out_path,lev,s,t,[cur_ver,'_lr']);
        end
        
        % resize to get the image in other lev
        for lev  = 2:lev_num-1
            pyr_PaSR{p2sr_iter}{t+t_c,s+s_c,lev} = ...
                imresize(pyr_PaSR{p2sr_iter}{t+t_c,s+s_c,lev_num},(1/lev_f)^(lev_num-lev),'bilinear');
        end
        
        psnr_PaSR{p2sr_iter}(t+t_c,s+s_c,lev_num) = GetPSNR(pyr_PaSR{p2sr_iter}{t+t_c,s+s_c,lev_num}, pyr_gt{t+t_c,s+s_c,lev_num});
        fprintf('psnr: %f\n',psnr_PaSR{p2sr_iter}(t+t_c,s+s_c,lev_num));
        
    end
end

