% compute t = 0 part image

lev = lev_num;

params.PhSR.filter_kernel = params.PhSR.filter_kernel_for_levels(lev);
params.PhSR.disp_range = params.PhSR.filter_kernel_for_levels(lev);

% syn with refine disp
pyr_PhSR{p2sr_iter} = pyr;
pyr_P2SR_syn{p2sr_iter} = pyr;

if params.PaSR_lr
    pyr_PaSR_cur = pyr_PaSR_lr;
else
    pyr_PaSR_cur = pyr_PaSR;
end

im_0 = pyr_PhSR{p2sr_iter}{t_c,s_c,lev};
im_ref = {};
im_ref_gt = {};

cur_ver = sprintf('PhSR_%d',p2sr_iter);
syn_params.type = 'wrap'; % warp,warp_lr

%%
% compute disp with PaSR
% version 1, direction compute disp with 9 high resoltion images
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% disp_init = CmpDispMulti(pyr_PaSR{p2sr_iter}(:,:,lev_num),t_c,s_c,params.PhSR,p2sr_iter);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% version 2,first downsampling, compute disp with 9 high resoltion images, then upsampling for low resoluton disp
disp_name = sprintf('%s/PhSR_disp_%d.mat',out_path,p2sr_iter);
if params.PhSR_disp_init_done(p2sr_iter)
    load(disp_name);
else
    disp_init_downsampling = CmpDispMulti1(pyr_PaSR_cur{p2sr_iter}(:,:,lev_num),t_c,s_c,params.PhSR,p2sr_iter);
    disp_init = restoreDisp(pyr_PaSR_cur{p2sr_iter}(:,:,lev_num), t_c,s_c,params.PhSR,p2sr_iter, disp_init_downsampling);
    save(disp_name,'disp_init_downsampling','disp_init');
end

t = 0;
if params.PhSR_done(p2sr_iter) && isMyIMExist(out_path,lev,s_end,t,cur_ver)
    
    k = 0;
    for s = 1:s_end
        k = k+1;
        pyr_PhSR{p2sr_iter}{t_c+t,s_c+s,lev} = MyReadIM(out_path,lev,s,t,cur_ver);
        if params.P2SR_syn_done(p2sr_iter)
            pyr_P2SR_syn{p2sr_iter}{t_c+t,s_c+s,lev} = MyReadIM(out_path,lev,s,t,[cur_ver,'_syn']);
        else
            pyr_P2SR_syn{p2sr_iter}{t_c+t,s_c+s,lev} = P2SR_syn(pyr_PhSR{p2sr_iter}{t_c+t,s_c+s,lev},pyr_PaSR_cur{p2sr_iter}{t_c+t,s_c+s,lev},syn_params);
            MySaveIM( pyr_P2SR_syn{p2sr_iter}{t_c+t,s_c+s,lev},out_path,lev,s,t,[cur_ver,'_syn']);
        end
        MySaveIM( pyr_P2SR_syn{p2sr_iter}{t_c+t,s_c+s,lev},out_path,lev,s,t,[cur_ver,'_syn']);
        
        disp{p2sr_iter}{t_c+t,s_c+s,lev} = MyReadDisp(out_path_disp,lev,s,t,cur_ver);
        
        psnr_PhSR{p2sr_iter}(t_c+t,s_c+s,lev) = GetPSNR(pyr_P2SR_syn{p2sr_iter}{t_c+t,s_c+s,lev},pyr_gt{t_c+t,s_c+s,lev});
        
    end
else
    k = 0;
    for s = 1:s_end
        k = k+1;
        im_ref{k} = pyr_PaSR_cur{p2sr_iter}{t_c + t,s_c+s,lev};
        im_ref_gt{k} = pyr_gt{t_c + t,s_c+s,lev};
    end
    % direction, left -> right
    [im_syn,disp_cur]= SynRefineWithInitDisp(im_0,disp_init,im_ref,im_ref_gt,params.PhSR);
    
    k = 0;
    for s = 1:s_end
        k = k+1;

        pyr_PhSR{p2sr_iter}{t_c + t,s_c+s,lev} = im_syn{k};
        pyr_P2SR_syn{p2sr_iter}{t_c+t,s_c+s,lev} = P2SR_syn(pyr_PhSR{p2sr_iter}{t_c+t,s_c+s,lev},pyr_PaSR_cur{p2sr_iter}{t_c+t,s_c+s,lev},syn_params);
        MySaveIM( pyr_P2SR_syn{p2sr_iter}{t_c+t,s_c+s,lev},out_path,lev,s,t,[cur_ver,'_syn']);
        
        disp{p2sr_iter}{t_c + t,s_c+s,lev} = disp_cur{k};   

        psnr_PhSR{p2sr_iter}(t_c + t ,s_c+s,lev) = GetPSNR(pyr_P2SR_syn{p2sr_iter}{t_c + t ,s_c+s,lev},pyr_gt{t_c + t ,s_c+s,lev});
        
        MySaveIM(im_syn{k},out_path,lev,s,t,cur_ver);     
        
        MySaveDisp(disp{p2sr_iter}{t_c+t,s_c+s,lev},out_path_disp,lev,s,t,cur_ver);
        
    end
end

fprintf('psnr_PhSR{p2sr_iter}:\n');
psnr_PhSR{p2sr_iter}(:,:,lev)

im_ref = {};
im_ref_gt = {};
k = 0;
t = 0;

if params.PhSR_done(p2sr_iter) && isMyIMExist(out_path,lev,s_begin,t,cur_ver)
    k = 0;
    for s = -1:-1:s_begin
        k = k+1;

        pyr_PhSR{p2sr_iter}{t_c+t,s_c+s,lev} = MyReadIM(out_path,lev,s,t,cur_ver);
        if params.P2SR_syn_done(p2sr_iter)
            pyr_P2SR_syn{p2sr_iter}{t_c+t,s_c+s,lev} = MyReadIM(out_path,lev,s,t,[cur_ver,'_syn']);
        else
            pyr_P2SR_syn{p2sr_iter}{t_c+t,s_c+s,lev} = P2SR_syn(pyr_PhSR{p2sr_iter}{t_c+t,s_c+s,lev},pyr_PaSR_cur{p2sr_iter}{t_c+t,s_c+s,lev},syn_params);
            MySaveIM( pyr_P2SR_syn{p2sr_iter}{t_c+t,s_c+s,lev},out_path,lev,s,t,[cur_ver,'_syn']);
        end
        
        disp{p2sr_iter}{t_c+t,s_c+s,lev} = MyReadDisp(out_path_disp,lev,s,t,cur_ver);
        
        psnr_PhSR{p2sr_iter}(t_c+t,s_c+s,lev) = GetPSNR(pyr_P2SR_syn{p2sr_iter}{t_c+t,s_c+s,lev},pyr_gt{t_c+t,s_c+s,lev});
        
    end
else
    k = 0;
    for s = -1:-1:s_begin
        k = k+1;
        im_ref{k} = MyFlipIM(pyr_PaSR_cur{p2sr_iter}{t_c,s_c+s,lev}, 'lr',0 );
        im_ref_gt{k} = MyFlipIM(pyr_gt{t_c,s_c+s,lev}, 'lr',0 );
    end
    [im_syn,disp_cur] = SynRefineWithInitDisp(MyFlipIM(im_0, 'lr',0 ),MyFlipIM(disp_init, 'lr',0 ),im_ref,im_ref_gt,params.PhSR);
    k = 0;
    for s = -1:-1:s_begin
        k = k+1;

        pyr_PhSR{p2sr_iter}{t_c+t,s_c+s,lev} = MyFlipIM(im_syn{k}, 'lr',0 );
        pyr_P2SR_syn{p2sr_iter}{t_c+t,s_c+s,lev} = P2SR_syn(pyr_PhSR{p2sr_iter}{t_c+t,s_c+s,lev},pyr_PaSR_cur{p2sr_iter}{t_c+t,s_c+s,lev},syn_params);
        MySaveIM( pyr_P2SR_syn{p2sr_iter}{t_c+t,s_c+s,lev},out_path,lev,s,t,[cur_ver,'_syn']);
         
        disp{p2sr_iter}{t_c+t,s_c+s,lev} = MyFlipIM(disp_cur{k}, 'lr',0 );
        psnr_PhSR{p2sr_iter}(t_c+t,s_c+s,lev) = GetPSNR(pyr_P2SR_syn{p2sr_iter}{t_c+t,s_c+s,lev},pyr_gt{t_c+t,s_c+s,lev});
        
        MySaveIM(MyFlipIM(im_syn{k}, 'lr',0 ),out_path,lev,s,t,cur_ver);
        
        MySaveDisp(disp{p2sr_iter}{t_c+t,s_c+s,lev},out_path_disp,lev,s,t,cur_ver);
    end
    
end
fprintf('psnr_PhSR{p2sr_iter}:\n');
psnr_PhSR{p2sr_iter}(:,:,lev)


% for each column
for s = s_begin:s_end
    
    im_0 = pyr_PhSR{p2sr_iter}{t_c,s_c+s,lev};
    
    im_ref = {};
    im_ref_gt = {};
    k = 0;
    if params.PhSR_done(p2sr_iter) && isMyIMExist(out_path,lev,s,t_end,cur_ver)
        k = 0;
        for t = 1:t_end
            k = k+1;

            pyr_PhSR{p2sr_iter}{t_c+t,s_c+s,lev} = MyReadIM(out_path,lev,s,t,cur_ver);
            if params.P2SR_syn_done(p2sr_iter)
                pyr_P2SR_syn{p2sr_iter}{t_c+t,s_c+s,lev} = MyReadIM(out_path,lev,s,t,[cur_ver,'_syn']);
            else
                pyr_P2SR_syn{p2sr_iter}{t_c+t,s_c+s,lev} = P2SR_syn(pyr_PhSR{p2sr_iter}{t_c+t,s_c+s,lev},pyr_PaSR_cur{p2sr_iter}{t_c+t,s_c+s,lev},syn_params);
                MySaveIM( pyr_P2SR_syn{p2sr_iter}{t_c+t,s_c+s,lev},out_path,lev,s,t,[cur_ver,'_syn']);
            end
            
            disp{p2sr_iter}{t_c+t,s_c+s,lev} = MyReadDisp(out_path_disp,lev,s,t,cur_ver);            
            psnr_PhSR{p2sr_iter}(t_c+t,s_c+s,lev) = GetPSNR(pyr_P2SR_syn{p2sr_iter}{t_c+t,s_c+s,lev},pyr_gt{t_c+t,s_c+s,lev});
            
        end
    else
        k = 0;
        for t = 1:t_end
            k = k+1;
            im_ref{k} = MyFlipIM(pyr_PaSR_cur{p2sr_iter}{t_c+t,s_c+s,lev},'',1);
            im_ref_gt{k} = MyFlipIM(pyr_gt{t_c+t,s_c+s,lev},'',1);
        end
        % direction, mid -> down
        [im_syn, disp_cur] = SynRefineWithInitDisp(MyFlipIM(im_0,'',1),MyFlipIM(disp_init,'',1),im_ref,im_ref_gt,params.PhSR);
        
        k = 0;
        for t = 1:t_end
            k = k+1;

            pyr_PhSR{p2sr_iter}{t_c+t,s_c+s,lev} = MyFlipIM(im_syn{k},'',1);
            pyr_P2SR_syn{p2sr_iter}{t_c+t,s_c+s,lev} = P2SR_syn(pyr_PhSR{p2sr_iter}{t_c+t,s_c+s,lev},pyr_PaSR_cur{p2sr_iter}{t_c+t,s_c+s,lev},syn_params);
            MySaveIM( pyr_P2SR_syn{p2sr_iter}{t_c+t,s_c+s,lev},out_path,lev,s,t,[cur_ver,'_syn']);
            
            disp{p2sr_iter}{t_c+t,s_c+s,lev} = MyFlipIM(disp_cur{k},'',1);
            
            psnr_PhSR{p2sr_iter}(t_c+t,s_c+s,lev) = GetPSNR(pyr_P2SR_syn{p2sr_iter}{t_c+t,s_c+s,lev},pyr_gt{t_c+t,s_c+s,lev});
            
            MySaveIM(MyFlipIM(im_syn{k}, '',1 ),out_path,lev,s,t,cur_ver);
            
            MySaveDisp(disp{p2sr_iter}{t_c+t,s_c+s,lev},out_path_disp,lev,s,t,cur_ver);
        end
    end
    

    fprintf('psnr_PhSR{p2sr_iter}:\n');
    psnr_PhSR{p2sr_iter}(:,:,lev)
    
    im_ref = {};
    im_ref_gt = {};
    k = 0;
    
    if params.PhSR_done(p2sr_iter) && isMyIMExist(out_path,lev,s,t_begin,cur_ver)
        k = 0;
         for t = -1:-1:t_begin
            k = k+1;
            
            pyr_PhSR{p2sr_iter}{t_c+t,s_c+s,lev} = MyReadIM(out_path,lev,s,t,cur_ver);
            if params.P2SR_syn_done(p2sr_iter)
                pyr_P2SR_syn{p2sr_iter}{t_c+t,s_c+s,lev} = MyReadIM(out_path,lev,s,t,[cur_ver,'_syn']);
            else
                pyr_P2SR_syn{p2sr_iter}{t_c+t,s_c+s,lev} = P2SR_syn(pyr_PhSR{p2sr_iter}{t_c+t,s_c+s,lev},pyr_PaSR_cur{p2sr_iter}{t_c+t,s_c+s,lev},syn_params);
                MySaveIM( pyr_P2SR_syn{p2sr_iter}{t_c+t,s_c+s,lev},out_path,lev,s,t,[cur_ver,'_syn']);
            end
            
            disp{p2sr_iter}{t_c+t,s_c+s,lev} = MyReadDisp(out_path_disp,lev,s,t,cur_ver);
            
            psnr_PhSR{p2sr_iter}(t_c+t,s_c+s,lev) = GetPSNR(pyr_P2SR_syn{p2sr_iter}{t_c+t,s_c+s,lev},pyr_gt{t_c+t,s_c+s,lev});
            
        end
    else
        k = 0;
        for t = -1:-1:t_begin
            k = k+1;
            im_ref{k} = MyFlipIM(pyr_PaSR_cur{p2sr_iter}{t_c+t,s_c+s,lev},'both',1);
            im_ref_gt{k} = MyFlipIM(pyr_gt{t_c+t,s_c+s,lev},'both',1);
        end
        % direction, mid -> up
        [im_syn disp_cur] = SynRefineWithInitDisp(MyFlipIM(im_0,'both',1),MyFlipIM(disp_init,'both',1),im_ref,im_ref_gt,params.PhSR);
        k = 0;
        for t = -1:-1:t_begin
            k = k+1;
            
            pyr_PhSR{p2sr_iter}{t_c+t,s_c+s,lev} = MyFlipIM(im_syn{k},'both',1);
            pyr_P2SR_syn{p2sr_iter}{t_c+t,s_c+s,lev} = P2SR_syn(pyr_PhSR{p2sr_iter}{t_c+t,s_c+s,lev},pyr_PaSR_cur{p2sr_iter}{t_c+t,s_c+s,lev},syn_params);
            MySaveIM( pyr_P2SR_syn{p2sr_iter}{t_c+t,s_c+s,lev},out_path,lev,s,t,[cur_ver,'_syn']);
            
            disp{p2sr_iter}{t_c+t,s_c+s,lev} = MyFlipIM(disp_cur{k},'both',1);
            psnr_PhSR{p2sr_iter}(t_c+t,s_c+s,lev) = GetPSNR(pyr_P2SR_syn{p2sr_iter}{t_c+t,s_c+s,lev},pyr_gt{t_c+t,s_c+s,lev});
            
            MySaveIM(MyFlipIM(im_syn{k},'both',1),out_path,lev,s,t,cur_ver);
            MySaveDisp(disp{p2sr_iter}{t_c+t,s_c+s,lev},out_path_disp,lev,s,t,cur_ver);
        end
        
    end
    %%
    fprintf('psnr_PhSR{p2sr_iter}:\n');
    psnr_PhSR{p2sr_iter}(:,:,lev_num)
    
end
fprintf('psnr_PhSR{p2sr_iter}:\n');
psnr_PhSR{p2sr_iter}(:,:,lev_num)





