% Matlab demo code accompanying the CVPR11 paper [C. Rhemann, A. Hosni,
% M. Bleyer, C. Rother, M. Gelautz, Fast Cost-Volume Filtering for Visual
% Correspondence and Beyond, CVPR11]
% Contributed by Christoph Rhemann (rhemann@ims.tuwien.ac.at)
%
% Please note that the running time and results reported in the paper is from a CUDA
% implementation. Hence, results and running times do not match this Matlab
% implementation.
function final_labels =  runStereoMatcher(im1,im2,name,params)
UseParallelToolbox = params.UseParallelToolbox;

% Parameter settings
r = params.filter_kernel;  % filter kernel in eq. (3) has size r \times r
eps = 0.0001;           % \epsilon in eq. (3)
thresColor = 2/255;     % \tau_1 in eq. (5)
thresGrad = 1/255;      % \tau_2 in eq. (5)
gamma = 0.11;           % (1- \alpha) in eq. (5)
threshBorder = 3/255;   % some threshold for border pixels
gamma_c = 0.1;          % \sigma_c in eq. (6)
gamma_d = 9;            % \sigma_s in eq. (6)
r_median = 50;          % filter kernel of weighted median in eq. (6) has size r_median \times r_median

% Compute disparity map for middlebury test images (vision.middlebury.edu/stereo/)
% for testimage = 1:4
testimage =2;
modifiedStereo;
% save(name,'dispVol','dispVol1','labels_left','labels_right');
% save(name)
%     example_referenceForCVPR11;
end